/*
 * Copyright (C) 2015, Wazuh Inc.
 *
 * This program is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General Public
 * License (version 2) as published by the FSF - Free Software
 * Foundation.
 */

#include <stdarg.h>
#include <stddef.h>
#include <setjmp.h>
#include <cmocka.h>
#include <stdio.h>
#include <string.h>

#include "../../wrappers/common.h"
#include "../../wrappers/wazuh/shared/string_op_wrappers.h"
#include "../../wazuh_modules/wmodules.h"
#include "../../headers/shared.h"
#include "../../wazuh_modules/vulnerability_detector/mocks_wm_vuln_detector.h"

/* redefinitons/wrapping */


int __wrap_wurl_request_uncompress_bz2_gz(const char * url, const char * dest, const char * header, const char * data, const long timeout) {
    if (url) check_expected(url);
    if (dest) check_expected(dest);
    if (header) check_expected(header);
    if (data) check_expected(data);
    if (timeout) check_expected(timeout);
    return mock();
}

int __wrap_w_uncompress_bz2_gz_file(const char * path, const char * dest) {
    if (path) check_expected(path);
    if (dest) check_expected(dest);
    return mock();
}

// wm_vuln_detector mocks

int __wrap_OS_ReadXML(__attribute__ ((__unused__)) const char *file,
                      __attribute__ ((__unused__)) OS_XML *_lxml) {
    return mock();
}

int __wrap_OS_ReadXML_Ex(__attribute__ ((__unused__)) const char *file,
                      __attribute__ ((__unused__)) OS_XML *_lxml) {
    return mock();
}

char* __wrap_OS_GetOneContentforElement(__attribute__ ((__unused__)) OS_XML *_lxml,
                                        __attribute__ ((__unused__)) const char **element_name) {
    return mock_type(char *);
}

void __wrap_OS_ClearXML(__attribute__ ((__unused__)) OS_XML *_lxml) {
    return;
}

xml_node **__wrap_OS_GetElementsbyNode(__attribute__ ((__unused__)) const OS_XML *_lxml,
                                       __attribute__ ((__unused__)) const xml_node *node) {
    return mock_type(xml_node **);
}

char * __wrap_w_get_file_content(__attribute__ ((__unused__)) const char * path,
                                 __attribute__ ((__unused__)) int max_size) {
    return mock_type(char *);
}

// wm_vuln_detector_evr mocks

struct tm *__wrap_localtime(__attribute__ ((__unused__)) const time_t *t) {
    return mock_type(struct tm *);
}
